Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3418)
@@ -7731,4 +9115,94 @@
            f_shf_green  = rho_cp / surf_usm_h%r_a_green(m)
         
+!***************************************************************************************
+if (surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) then
+!--    Adapted from LSM:
+!--    Second step: calculate canopy resistance r_canopy
+!--    f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
+ 
+!--    f1: correction for incoming shortwave radiation (stomata close at 
+!--    night)
+       f1 = MIN( 1.0_wp, ( 0.004_wp * surf_usm_h%rad_sw_in(m) + 0.05_wp ) / &
+                        (0.81_wp * (0.004_wp * surf_usm_h%rad_sw_in(m)      &
+                         + 1.0_wp)) )
+!
+!--    f2: correction for soil moisture availability to plants (the 
+!--    integrated soil moisture must thus be considered here)
+!--    f2 = 0 for very dry soils
+          m_total = 0.0_wp
+          DO  k = nzb_wall, nzt_wall+1
+              m_total = m_total + rootfr_h(nzb_wall,m)                              &
+                        * MAX(swc_h(nzb_wall,m),wilt_h(nzb_wall,m))
+          ENDDO 
+
+          IF ( m_total > wilt_h(nzb_wall,m)  .AND.  m_total < fc_h(nzb_wall,m) )  THEN
+             f2 = ( m_total - wilt_h(nzb_wall,m) ) / (fc_h(nzb_wall,m) - wilt_h(nzb_wall,m) )
+          ELSEIF ( m_total >= fc_h(nzb_wall,m) )  THEN
+             f2 = 1.0_wp
+          ELSE
+             f2 = 1.0E-20_wp
+          ENDIF
+
+!
+!--    Calculate water vapour pressure at saturation 
+       e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surf_green_h(m) &
+                     - 273.16_wp ) / ( t_surf_green_h(m) - 35.86_wp ) )
+!
+!--    f3: correction for vapour pressure deficit
+       IF ( surf_usm_h%g_d(m) /= 0.0_wp )  THEN
+!
+!--       Calculate vapour pressure
+          e  = qv1 * surface_pressure / ( qv1 + 0.622_wp )
+          f3 = EXP ( - surf_usm_h%g_d(m) * (e_s - e) )
+       ELSE
+          f3 = 1.0_wp
+       ENDIF
+
+!
+!--    Calculate canopy resistance. In case that c_veg is 0 (bare soils),
+!--    this calculation is obsolete, as r_canopy is not used below.
+!--    To do: check for very dry soil -> r_canopy goes to infinity
+       surf_usm_h%r_canopy(m) = surf_usm_h%r_canopy_min(m) /                               &
+                              ( surf_usm_h%lai(m) * f1 * f2 * f3 + 1.0E-20_wp )
+
+!
+!--    Calculate the maximum possible liquid water amount on plants and
+!--    bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
+!--    assumed, while paved surfaces might hold up 1 mm of water. The 
+!--    liquid water fraction for paved surfaces is calculated after 
+!--    Noilhan & Planton (1989), while the ECMWF formulation is used for
+!--    vegetated surfaces and bare soils.
+       m_liq_max = m_max_depth * ( surf_usm_h%lai(m) )
+       surf_usm_h%c_liq(m) = MIN( 1.0_wp, ( m_liq_usm_h%var_usm_1d(m) / m_liq_max )**0.67 )
+!
+!--    Calculate saturation specific humidity
+       q_s = 0.622_wp * e_s / ( surface_pressure - e_s )
+!
+!--    In case of dewfall, set evapotranspiration to zero
+!--    All super-saturated water is then removed from the air
+       IF ( humidity  .AND.  q_s <= qv1 )  THEN
+          surf_usm_h%r_canopy(m) = 0.0_wp
+       ENDIF
+
+!
+!--    Calculate coefficients for the total evapotranspiration 
+!--    In case of water surface, set vegetation and soil fluxes to zero.
+!--    For pavements, only evaporation of liquid water is possible.
+       f_qsws_veg  = rho_lv *                                &
+                         ( 1.0_wp        - surf_usm_h%c_liq(m)    ) /   &
+                         ( surf_usm_h%r_a_green(m) + surf_usm_h%r_canopy(m) )
+       f_qsws_liq  = rho_lv * surf_usm_h%c_liq(m)   /             &
+                           surf_usm_h%r_a_green(m)
+
+       f_qsws = f_qsws_veg + f_qsws_liq
+!
+!--    Calculate derivative of q_s for Taylor series expansion
+       e_s_dt = e_s * ( 17.269_wp / ( t_surf_green_h(m) - 35.86_wp) -   &
+                        17.269_wp*( t_surf_green_h(m) - 273.16_wp)      &
+                       / ( t_surf_green_h(m) - 35.86_wp)**2 )
+
+       dq_s_dt = 0.622_wp * e_s_dt / ( surface_pressure - e_s_dt )
+endif
+!***********************************************************************************
 !--        add LW up so that it can be removed in prognostic equation
            surf_usm_h%rad_net_l(m) = surf_usm_h%rad_sw_in(m)  -                &
@@ -7742,7 +9216,8 @@
            coef_1 = surf_usm_h%rad_net_l(m) +                                  & 
                  ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(ind_veg_wall,m) * &
-                                       sigma_sb * t_surf_h(m) ** 4 +           &  
+                                       sigma_sb * t_surf_wall_h(m) ** 4 +           &  
                                        f_shf * surf_usm_h%pt1(m) +             &
                                        lambda_surface * t_wall_h(nzb_wall,m)
+if ((.NOT. spinup).AND.(surf_usm_h%frac(ind_wat_win,m).GT.0.0_wp)) then
            coef_window_1 = surf_usm_h%rad_net_l(m) +                           & 
                    ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(ind_wat_win,m)  &
@@ -7750,29 +9225,49 @@
                                        f_shf_window * surf_usm_h%pt1(m) +      &
                                        lambda_surface_window * t_window_h(nzb_wall,m)
+endif                 
+         IF ( (humidity).and.(surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) )  THEN
+                    coef_green_1 = surf_usm_h%rad_net_l(m) +                              & 
+                   ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(ind_pav_green,m) * sigma_sb * &
+                                       t_surf_green_h(m) ** 4 +                  &  
+                                          f_shf_green * surf_usm_h%pt1(m) + f_qsws * ( qv1 - q_s    &
+                                          + dq_s_dt * t_surf_green_h(m) )        &
+                                          +lambda_surface_green * t_green_h(nzb_wall,m)
+           ELSE
            coef_green_1 = surf_usm_h%rad_net_l(m) +                            & 
                  ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(ind_pav_green,m) *&
                                        sigma_sb * t_surf_green_h(m) ** 4 +     &  
                                        f_shf_green * surf_usm_h%pt1(m) +       &
-                                       lambda_surface_green * t_wall_h(nzb_wall,m)
+                                       lambda_surface_green * t_green_h(nzb_wall,m)
+          ENDIF
 
 !--        denominator of the prognostic equation
            coef_2 = 4.0_wp * surf_usm_h%emissivity(ind_veg_wall,m) *           &
-                             sigma_sb * t_surf_h(m) ** 3                       &
+                             sigma_sb * t_surf_wall_h(m) ** 3                       &
                            + lambda_surface + f_shf / exner(k)
+if ((.NOT. spinup).AND.(surf_usm_h%frac(ind_wat_win,m).GT.0.0_wp)) then
            coef_window_2 = 4.0_wp * surf_usm_h%emissivity(ind_wat_win,m) *     &
                              sigma_sb * t_surf_window_h(m) ** 3                &
                            + lambda_surface_window + f_shf_window / exner(k)
-           coef_green_2 = 4.0_wp * surf_usm_h%emissivity(ind_pav_green,m) *    &
-                             sigma_sb * t_surf_green_h(m) ** 3                 &
+endif
+           IF ( (humidity).and.(surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) )  THEN
+              coef_green_2 = 4.0_wp * surf_usm_h%emissivity(ind_pav_green,m) * sigma_sb *    &
+                                t_surf_green_h(m) ** 3 + f_qsws * dq_s_dt        &
+                              + lambda_surface_green + f_shf_green / exner(k)
+           ELSE
+           coef_green_2 = 4.0_wp * surf_usm_h%emissivity(ind_pav_green,m) * sigma_sb *    &
+                             t_surf_green_h(m) ** 3                           &
                            + lambda_surface_green + f_shf_green / exner(k)
+           ENDIF
 
 !--        implicit solution when the surface layer has no heat capacity,
 !--        otherwise use RK3 scheme.
-           t_surf_h_p(m) = ( coef_1 * dt_3d * tsc(2) +                        &
-                             surf_usm_h%c_surface(m) * t_surf_h(m) ) /        & 
+           t_surf_wall_h_p(m) = ( coef_1 * dt_3d * tsc(2) +                        &
+                             surf_usm_h%c_surface(m) * t_surf_wall_h(m) ) /        & 
                            ( surf_usm_h%c_surface(m) + coef_2 * dt_3d * tsc(2) ) 
+if ((.NOT. spinup).AND.(surf_usm_h%frac(ind_wat_win,m).GT.0.0_wp)) then
            t_surf_window_h_p(m) = ( coef_window_1 * dt_3d * tsc(2) +                        &
                              surf_usm_h%c_surface_window(m) * t_surf_window_h(m) ) /        & 
-                           ( surf_usm_h%c_surface_window(m) + coef_window_2 * dt_3d * tsc(2) ) 
+                           ( surf_usm_h%c_surface_window(m) + coef_window_2 * dt_3d * tsc(2) )
+endif
            t_surf_green_h_p(m) = ( coef_green_1 * dt_3d * tsc(2) +                        &
                              surf_usm_h%c_surface_green(m) * t_surf_green_h(m) ) /        & 
@@ -7780,8 +9275,10 @@
 
 !--        add RK3 term
-           t_surf_h_p(m) = t_surf_h_p(m) + dt_3d * tsc(3) *                   &
-                           surf_usm_h%tt_surface_m(m)
+           t_surf_wall_h_p(m) = t_surf_wall_h_p(m) + dt_3d * tsc(3) *                   &
+                           surf_usm_h%tt_surface_wall_m(m)
+
            t_surf_window_h_p(m) = t_surf_window_h_p(m) + dt_3d * tsc(3) *     &
                            surf_usm_h%tt_surface_window_m(m)
+
            t_surf_green_h_p(m) = t_surf_green_h_p(m) + dt_3d * tsc(3) *       &
                            surf_usm_h%tt_surface_green_m(m)
@@ -7790,5 +9287,5 @@
 !--        store also vpt_surface, which is, due to the lack of moisture on roofs simply
 !--        assumed to be the surface temperature.
-           surf_usm_h%pt_surface(m) = ( surf_usm_h%frac(ind_veg_wall,m) * t_surf_h_p(m)   &
+           surf_usm_h%pt_surface(m) = ( surf_usm_h%frac(ind_veg_wall,m) * t_surf_wall_h_p(m)   &
                                + surf_usm_h%frac(ind_wat_win,m) * t_surf_window_h_p(m)   &
                                + surf_usm_h%frac(ind_pav_green,m) * t_surf_green_h_p(m) )  &
@@ -7799,6 +9296,6 @@
 
 !--        calculate true tendency
-           stend = ( t_surf_h_p(m) - t_surf_h(m) - dt_3d * tsc(3) *           &
-                     surf_usm_h%tt_surface_m(m)) / ( dt_3d  * tsc(2) )
+           stend_wall = ( t_surf_wall_h_p(m) - t_surf_wall_h(m) - dt_3d * tsc(3) *           &
+                     surf_usm_h%tt_surface_wall_m(m)) / ( dt_3d  * tsc(2) )
            stend_window = ( t_surf_window_h_p(m) - t_surf_window_h(m) - dt_3d * tsc(3) *        &
                      surf_usm_h%tt_surface_window_m(m)) / ( dt_3d  * tsc(2) )
@@ -7809,11 +9306,11 @@
            IF ( timestep_scheme(1:5) == 'runge' )  THEN
               IF ( intermediate_timestep_count == 1 )  THEN
-                 surf_usm_h%tt_surface_m(m) = stend
+                 surf_usm_h%tt_surface_wall_m(m) = stend_wall
                  surf_usm_h%tt_surface_window_m(m) = stend_window
                  surf_usm_h%tt_surface_green_m(m) = stend_green
               ELSEIF ( intermediate_timestep_count <                          &
                         intermediate_timestep_count_max )  THEN
-                 surf_usm_h%tt_surface_m(m) = -9.5625_wp * stend +            &
-                                     5.3125_wp * surf_usm_h%tt_surface_m(m)
+                 surf_usm_h%tt_surface_wall_m(m) = -9.5625_wp * stend_wall +            &
+                                     5.3125_wp * surf_usm_h%tt_surface_wall_m(m)
                  surf_usm_h%tt_surface_window_m(m) = -9.5625_wp * stend_window +   &
                                      5.3125_wp * surf_usm_h%tt_surface_window_m(m)
@@ -7825,8 +9322,8 @@
 !--        in case of fast changes in the skin temperature, it is required to
 !--        update the radiative fluxes in order to keep the solution stable
-           IF ( ( ( ABS( t_surf_h_p(m) - t_surf_h(m) ) > 1.0_wp ) .OR.           &
-                ( ABS( t_surf_green_h_p(m) - t_surf_green_h(m) ) > 1.0_wp ) .OR. &
-                ( ABS( t_surf_window_h_p(m) - t_surf_window_h(m) ) > 1.0_wp ) )  &
-                 .AND.  unscheduled_radiation_calls  ) THEN
+           IF ( ( ( ABS( t_surf_wall_h_p(m)   - t_surf_wall_h(m) )   > 1.0_wp )   .OR. &
+                (   ABS( t_surf_green_h_p(m)  - t_surf_green_h(m) )  > 1.0_wp )   .OR. &
+                (   ABS( t_surf_window_h_p(m) - t_surf_window_h(m) ) > 1.0_wp ) )      &
+                   .AND.  unscheduled_radiation_calls  )  THEN
               force_radiation_call_l = .TRUE.
            ENDIF
@@ -7837,5 +9334,5 @@
                                      surf_usm_h%frac(ind_veg_wall,m) *                   &
                                      sigma_sb * surf_usm_h%emissivity(ind_veg_wall,m) *  &
-                                     ( t_surf_h_p(m)**4 - t_surf_h(m)**4 )               &
+                                     ( t_surf_wall_h_p(m)**4 - t_surf_wall_h(m)**4 )               &
                                     + surf_usm_h%frac(ind_wat_win,m) *                   &
                                      sigma_sb * surf_usm_h%emissivity(ind_wat_win,m) *   &
@@ -7846,5 +9343,5 @@
 
            surf_usm_h%wghf_eb(m)   = lambda_surface *                         &
-                                      ( t_surf_h_p(m) - t_wall_h(nzb_wall,m) )
+                                      ( t_surf_wall_h_p(m) - t_wall_h(nzb_wall,m) )
            surf_usm_h%wghf_eb_green(m)  = lambda_surface_green *                         &
                                           ( t_surf_green_h_p(m) - t_green_h(nzb_wall,m) )
@@ -7854,5 +9351,5 @@
 !
 !--        ground/wall/roof surface heat flux
-           surf_usm_h%wshf_eb(m)   = - f_shf  * ( surf_usm_h%pt1(m) - t_surf_h_p(m) / exner(k) ) *               &
+           surf_usm_h%wshf_eb(m)   = - f_shf  * ( surf_usm_h%pt1(m) - t_surf_wall_h_p(m) / exner(k) ) *               &
                                        surf_usm_h%frac(ind_veg_wall,m)         &
                                      - f_shf_window  * ( surf_usm_h%pt1(m) - t_surf_window_h_p(m) / exner(k) ) * &
@@ -7865,4 +9362,124 @@
            surf_usm_h%shf(m) = surf_usm_h%wshf_eb(m) / c_p
       
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+if (surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) then
+
+! print*, "tsurfroofgreen",m,t_surf_green_h_p(m),i,j,k,surf_usm_h%wghf_eb_green(m),surf_usm_h%rad_net_l(m),&
+!         surf_usm_h%wshf_eb(m),f_qsws_veg,f_qsws_liq,dq_s_dt
+! print*, "B",surf_usm_h%rad_sw_in(m),surf_usm_h%rad_sw_out(m),surf_usm_h%rad_lw_in(m),surf_usm_h%rad_lw_out(m)
+! print*, "lambdasurface",lambda_surface_green,lambda_surface,i,j,k
+! print*, "fractions",i,j,k,surf_usm_h%frac(0:2,m)
+if ((t_surf_green_h_p(m).gt.370.0_wp).or.(t_surf_green_h_p(m).lt.250.0_wp)) then
+  print*, t_surf_green_h_p(m),m,i,j,k
+  stop
+endif
+
+       IF ( humidity )  THEN
+          surf_usm_h%qsws_eb(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt                     &
+                          * t_surf_green_h(m) - dq_s_dt *               &
+                            t_surf_green_h_p(m) )
+
+          surf_usm_h%qsws(m) = surf_usm_h%qsws_eb(m) / rho_lv
+
+          surf_usm_h%qsws_veg_eb(m)  = - f_qsws_veg  * ( qv1 - q_s                      &
+                              + dq_s_dt * t_surf_green_h(m) - dq_s_dt   &
+                              * t_surf_green_h_p(m) )
+
+          surf_usm_h%qsws_liq_eb(m)  = - f_qsws_liq  * ( qv1 - q_s                      &
+                              + dq_s_dt * t_surf_green_h(m) - dq_s_dt   &
+                              * t_surf_green_h_p(m) )
+       ENDIF
+
+!
+!--    Calculate the true surface resistance
+       IF ( .NOT.  humidity )  THEN
+          surf_usm_h%r_s(m) = 1.0E10_wp
+       ELSE
+          surf_usm_h%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt                       &
+                          *  t_surf_green_h(m) - dq_s_dt *               &
+                            t_surf_green_h_p(m) ) /                     &
+                            (surf_usm_h%qsws(m) + 1.0E-20)  - surf_usm_h%r_a_green(m)
+       ENDIF
+
+!
+!--    Calculate change in liquid water reservoir due to dew fall or 
+!--    evaporation of liquid water
+       IF ( humidity )  THEN
+!
+!--       If precipitation is activated, add rain water to qsws_liq
+!--       and qsws_soil according the the vegetation coverage.
+!--       precipitation_rate is given in mm.
+          IF ( precipitation )  THEN
+
+!
+!--          Add precipitation to liquid water reservoir, if possible.
+!--          Otherwise, add the water to soil. In case of
+!--          pavements, the exceeding water amount is implicitely removed 
+!--          as runoff as qsws_soil is then not used in the soil model
+             IF ( m_liq_usm_h%var_usm_1d(m) /= m_liq_max )  THEN
+                surf_usm_h%qsws_liq_eb(m) = surf_usm_h%qsws_liq_eb(m)                            &
+                                 + surf_usm_h%frac(ind_pav_green,m) * prr(k+k_off,j+j_off,i+i_off)&
+                                 * hyrho(k+k_off)                              &
+                                 * 0.001_wp * rho_l * l_v
+             ENDIF
+
+          ENDIF
+
+!
+!--       If the air is saturated, check the reservoir water level
+          IF ( surf_usm_h%qsws(m) < 0.0_wp )  THEN
+!
+!--          Check if reservoir is full (avoid values > m_liq_max)
+!--          In that case, qsws_liq goes to qsws_soil. In this 
+!--          case qsws_veg is zero anyway (because c_liq = 1),       
+!--          so that tend is zero and no further check is needed
+             IF ( m_liq_usm_h%var_usm_1d(m) == m_liq_max )  THEN
+!                 surf_usm_h%qsws_soil(m) = surf_usm_h%qsws_soil(m) + surf_usm_h%qsws_liq(m)
+
+                surf_usm_h%qsws_liq_eb(m)  = 0.0_wp
+             ENDIF
+
+!
+!--          In case qsws_veg becomes negative (unphysical behavior), 
+!--          let the water enter the liquid water reservoir as dew on the
+!--          plant
+             IF ( surf_usm_h%qsws_veg_eb(m) < 0.0_wp )  THEN
+                surf_usm_h%qsws_liq_eb(m) = surf_usm_h%qsws_liq_eb(m) + surf_usm_h%qsws_veg_eb(m)
+                surf_usm_h%qsws_veg_eb(m) = 0.0_wp
+             ENDIF
+          ENDIF                    
+ 
+          surf_usm_h%qsws(m) = surf_usm_h%qsws(m) / l_v
+ 
+          tend = - surf_usm_h%qsws_liq_eb(m) * drho_l_lv
+          m_liq_usm_h_p%var_usm_1d(m) = m_liq_usm_h%var_usm_1d(m) + dt_3d *    &
+                                        ( tsc(2) * tend +                      &
+                                          tsc(3) * tm_liq_usm_h_m%var_usm_1d(m) )
+!
+!--       Check if reservoir is overfull -> reduce to maximum
+!--       (conservation of water is violated here)
+          m_liq_usm_h_p%var_usm_1d(m) = MIN( m_liq_usm_h_p%var_usm_1d(m),m_liq_max )
+
+!
+!--       Check if reservoir is empty (avoid values < 0.0)
+!--       (conservation of water is violated here)
+          m_liq_usm_h_p%var_usm_1d(m) = MAX( m_liq_usm_h_p%var_usm_1d(m), 0.0_wp )
+!
+!--       Calculate m_liq tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                tm_liq_usm_h_m%var_usm_1d(m) = tend
+             ELSEIF ( intermediate_timestep_count <                            &
+                      intermediate_timestep_count_max )  THEN
+                tm_liq_usm_h_m%var_usm_1d(m) = -9.5625_wp * tend +             &
+                                              5.3125_wp * tm_liq_usm_h_m%var_usm_1d(m)
+             ENDIF
+          ENDIF
+
+       ENDIF
+else
+  surf_usm_h%r_s(m) = 1.0E10_wp
+endif
+
        ENDDO
 !
@@ -7886,7 +9503,20 @@
 
 #if ! defined( __nopointer )          
+!            pt1  = pt(k,j,i)
+           IF ( humidity )  THEN
+              qv1 = q(k,j,i)
+           ELSE
+              qv1 = 0.0_wp
+           ENDIF
 !
 !--          calculate rho * c_p coefficient at wall layer
              rho_cp  = c_p * hyp(k) / ( r_d * surf_usm_v(l)%pt1(m) * exner(k) )
+             
+if (surf_usm_v(l)%frac(1,m).gt.0.0_wp) then
+!
+!--         Calculate frequently used parameters
+            rho_lv    = rho_cp / c_p * l_v
+            drho_l_lv = 1.0_wp / (rho_l * l_v)
+endif
 #endif
 
@@ -7932,4 +9562,96 @@
              f_shf_green   = rho_cp / surf_usm_v(l)%r_a(m)
 
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+if (surf_usm_v(l)%frac(1,m).gt.0.0_wp) then
+!--    Adapted from LSM:
+!--    Second step: calculate canopy resistance r_canopy
+!--    f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
+ 
+!--    f1: correction for incoming shortwave radiation (stomata close at 
+!--    night)
+       f1 = MIN( 1.0_wp, ( 0.004_wp * surf_usm_v(l)%rad_sw_in(m) + 0.05_wp ) / &
+                        (0.81_wp * (0.004_wp * surf_usm_v(l)%rad_sw_in(m)      &
+                         + 1.0_wp)) )
+!
+!--    f2: correction for soil moisture availability to plants (the 
+!--    integrated soil moisture must thus be considered here)
+!--    f2 = 0 for very dry soils
+
+f2=1.0_wp
+!           m_total = 0.0_wp
+!           DO  k = nzb_wall, nzt_wall+1
+!               m_total = m_total + rootfr_h(nzb_wall,m)                              &
+!                         * MAX(swc_h(nzb_wall,m),wilt_h(nzb_wall,m))
+!           ENDDO 
+! 
+!           IF ( m_total > wilt_h(nzb_wall,m)  .AND.  m_total < fc_h(nzb_wall,m) )  THEN
+!              f2 = ( m_total - wilt_h(nzb_wall,m) ) / (fc_h(nzb_wall,m) - wilt_h(nzb_wall,m) )
+!           ELSEIF ( m_total >= fc_h(nzb_wall,m) )  THEN
+!              f2 = 1.0_wp
+!           ELSE
+!              f2 = 1.0E-20_wp
+!           ENDIF
+
+!
+!--    Calculate water vapour pressure at saturation 
+       e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * (  t_surf_green_v_p(l)%t(m) &
+                     - 273.16_wp ) / (  t_surf_green_v_p(l)%t(m) - 35.86_wp ) )
+!
+!--    f3: correction for vapour pressure deficit
+       IF ( surf_usm_v(l)%g_d(m) /= 0.0_wp )  THEN
+!
+!--       Calculate vapour pressure
+          e  = qv1 * surface_pressure / ( qv1 + 0.622_wp )
+          f3 = EXP ( - surf_usm_v(l)%g_d(m) * (e_s - e) )
+       ELSE
+          f3 = 1.0_wp
+       ENDIF
+!
+!--    Calculate canopy resistance. In case that c_veg is 0 (bare soils),
+!--    this calculation is obsolete, as r_canopy is not used below.
+!--    To do: check for very dry soil -> r_canopy goes to infinity
+       surf_usm_v(l)%r_canopy(m) = surf_usm_v(l)%r_canopy_min(m) /                               &
+                              ( surf_usm_v(l)%lai(m) * f1 * f2 * f3 + 1.0E-20_wp )
+                              
+! !--    Calculate the maximum possible liquid water amount on plants and
+! !--    bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
+! !--    assumed, while paved surfaces might hold up 1 mm of water. The 
+! !--    liquid water fraction for paved surfaces is calculated after 
+! !--    Noilhan & Planton (1989), while the ECMWF formulation is used for
+! !--    vegetated surfaces and bare soils.
+! ! surf_usm_h%lai(m)=4.0_wp
+!        m_liq_max = m_max_depth * ( surf_usm_h%lai(m) )
+!        surf_usm_h%c_liq(m) = MIN( 1.0_wp, ( m_liq_usm_h%var_usm_1d(m) / m_liq_max )**0.67 )
+!
+!--    Calculate saturation specific humidity
+       q_s = 0.622_wp * e_s / ( surface_pressure - e_s )
+!
+!--    In case of dewfall, set evapotranspiration to zero
+!--    All super-saturated water is then removed from the air
+       IF ( humidity  .AND.  q_s <= qv1 )  THEN
+          surf_usm_v(l)%r_canopy(m) = 0.0_wp
+       ENDIF
+
+!
+!--    Calculate coefficients for the total evapotranspiration 
+!--    In case of water surface, set vegetation and soil fluxes to zero.
+!--    For pavements, only evaporation of liquid water is possible.
+       f_qsws_veg  = rho_lv *                                &
+                         ( 1.0_wp        - 0.0_wp ) / & !surf_usm_h%c_liq(m)    ) /   &
+                         ( surf_usm_v(l)%r_a(m) + surf_usm_v(l)%r_canopy(m) )
+!        f_qsws_liq  = rho_lv * surf_usm_h%c_liq(m)   /             &
+!                            surf_usm_h%r_a_green(m)
+
+       f_qsws = f_qsws_veg! + f_qsws_liq
+!
+!--    Calculate derivative of q_s for Taylor series expansion
+       e_s_dt = e_s * ( 17.269_wp / ( t_surf_green_v_p(l)%t(m) - 35.86_wp) -   &
+                        17.269_wp*( t_surf_green_v_p(l)%t(m) - 273.16_wp)      &
+                       / ( t_surf_green_v_p(l)%t(m) - 35.86_wp)**2 )
+
+       dq_s_dt = 0.622_wp * e_s_dt / ( surface_pressure - e_s_dt )
+endif
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                
 !--          add LW up so that it can be removed in prognostic equation
              surf_usm_v(l)%rad_net_l(m) = surf_usm_v(l)%rad_sw_in(m)  -        &
@@ -7938,10 +9660,21 @@
                                           surf_usm_v(l)%rad_lw_out(m)
 
+if ((abs(t_surf_wall_v(l)%t(m)-276.).gt.100.).or.(abs(t_surf_window_v(l)%t(m)-276.).gt.300.) &
+.or.(abs(t_surf_green_v(l)%t(m)-276.).gt.100)) then
+print*, "tsurfvvvv",m,t_surf_wall_v(l)%t(m),t_surf_window_v(l)%t(m),t_surf_green_v(l)%t(m)
+print*, "params", surf_usm_v(l)%emissivity(ind_veg_wall,m),lambda_surface, t_wall_v(l)%t(nzb_wall:nzt_wall,m), &
+                  surf_usm_v(l)%emissivity(ind_wat_win,m),lambda_surface_window,t_window_v(l)%t(nzb_wall:nzt_wall,m),t_green_v(l)%t(nzb_wall:nzt_wall,m)
+print*, "dicken",surf_usm_v(l)%zw(nzb_wall:nzt_wall,m),surf_usm_v(l)%zw_window(nzb_wall:nzt_wall,m),surf_usm_v(l)%zw_green(nzb_wall:nzt_wall,m)
+print*, "c",surf_usm_v(l)%c_surface_window(m),surf_usm_v(l)%c_surface(m)
+!if ((abs(t_surf_v(l)%t(m)-276.).gt.10.).or.(abs(t_surf_window_v(l)%t(m)-276.).gt.10.)) then
+stop
+endif
 !--           numerator of the prognostic equation
               coef_1 = surf_usm_v(l)%rad_net_l(m) +                            & ! coef +1 corresponds to -lwout included in calculation of radnet_l
              ( 3.0_wp + 1.0_wp ) * surf_usm_v(l)%emissivity(ind_veg_wall,m) *  &
-                                     sigma_sb *  t_surf_v(l)%t(m) ** 4 +       &  
+                                     sigma_sb *  t_surf_wall_v(l)%t(m) ** 4 +       &  
                                      f_shf * surf_usm_v(l)%pt1(m) +            &
                                      lambda_surface * t_wall_v(l)%t(nzb_wall,m)
+if ((.NOT. spinup).AND.(surf_usm_v(l)%frac(ind_wat_win,m).GT.0.0_wp)) then
               coef_window_1 = surf_usm_v(l)%rad_net_l(m) +                     & ! coef +1 corresponds to -lwout included in calculation of radnet_l
                ( 3.0_wp + 1.0_wp ) * surf_usm_v(l)%emissivity(ind_wat_win,m) * &
